std::__debug::list< _Tp, _Allocator >(3)

NAME
std::__debug::list< _Tp, _Allocator > -

SYNOPSIS

Inherits list< _Tp, _Allocator >, and __gnu_debug::_Safe_sequence< list< _Tp, _Allocator > >.

  Public Types
typedef _Allocator allocator_type
typedef
__gnu_debug::_Safe_iterator
< _Base_const_iterator, list > const_iterator"
typedef _Base::const_pointer const_pointer
typedef _Base::const_reference const_reference
typedef std::reverse_iterator
< const_iterator > const_reverse_iterator"
typedef _Base::difference_type difference_type
typedef
__gnu_debug::_Safe_iterator
< _Base_iterator, list > iterator"
typedef _Base::pointer pointer
typedef _Base::reference reference
typedef std::reverse_iterator
< iterator > reverse_iterator"
typedef _Base::size_type size_type
typedef _Tp value_type

  Public Member Functions
_Base::splice (__position.base(), std::move(__x._M_base()))
_Base::splice (__position.base(), std::move(__x._M_base()), __i.base())
void _M_attach (_Safe_iterator_base *__it, bool __constant)
void _M_attach_single (_Safe_iterator_base *__it, bool __constant) throw ()
_Base & _M_base () noexcept
const _Base & _M_base () const noexcept
void _M_detach (_Safe_iterator_base *__it)
void _M_detach_single (_Safe_iterator_base *__it) throw ()
void _M_invalidate_all () const
void _M_invalidate_if (_Predicate __pred)
void _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
this _M_transfer_from_if (__x, _Not_equal(__x._M_base().end()))
this _M_transfer_from_if (__x, _Equal(__i.base()))
reference back ()
const_reference back () const
const _Tp const _Allocator iterator begin () noexcept
const_iterator begin () const noexcept
const_iterator cbegin () const noexcept
const_iterator cend () const noexcept
void clear () noexcept
const_reverse_iterator crbegin () const noexcept
const_reverse_iterator crend () const noexcept
template<typename... _Args> iterator emplace (iterator __position, _Args &&...__args)
iterator end () noexcept
const_iterator end () const noexcept
iterator erase (iterator __position)
iterator erase (iterator __position, iterator __last)
reference front ()
const_reference front () const
iterator insert (iterator __position, const _Tp &__x)
iterator insert (iterator __position, _Tp &&__x)
void insert (iterator __p, initializer_list< value_type > __l)
void insert (iterator __position, size_type __n, const _Tp &__x)
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
void pop_back ()
void pop_front ()
reverse_iterator rbegin () noexcept
const_reverse_iterator rbegin () const noexcept
void remove (const _Tp &__value)
template<class _Predicate > void remove_if (_Predicate __pred)
reverse_iterator rend () noexcept
const_reverse_iterator rend () const noexcept
void resize (size_type __sz)
void resize (size_type __sz, const _Tp &__c)
void splice (iterator __position, list &__x)
void splice (iterator __position, list &__x, iterator __i)
void splice (iterator __position, list &&__x, iterator __first, iterator __last)
void splice (iterator __position, list &__x, iterator __first, iterator __last)
void swap (list &__x)
void unique ()
template<class _BinaryPredicate > void unique (_BinaryPredicate __binary_pred)
while (false)
while (false)
while (false)

  Public Attributes
const _Tp const _Allocator & __a
__pad0__: _Base(__a) { } explicit list(size_type __n) : _Base(__n) { } list(size_type __n
const _Tp & __value
_Safe_iterator_base * _M_const_iterators
_Safe_iterator_base * _M_iterators
unsigned int _M_version
do
void

  Protected Member Functions
void _M_detach_all ()
void _M_detach_singular ()
__gnu_cxx::__mutex & _M_get_mutex () throw ()
void _M_revalidate_singular ()
void _M_swap (_Safe_sequence_base &__x)

Detailed Description

  template<typename _Tp, typename _Allocator = std::allocator<_Tp>>class std::__debug::list< _Tp, _Allocator >
Class std::list with safety/checking/debug instrumentation.

Definition at line 42 of file debug/list.

Member Function Documentation

  void __gnu_debug::_Safe_sequence_base::_M_attach (_Safe_iterator_base *__it, bool__constant) [inherited]
Attach an iterator to this sequence.

  void __gnu_debug::_Safe_sequence_base::_M_attach_single (_Safe_iterator_base *__it, bool__constant) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_detach (_Safe_iterator_base *__it) [inherited]
Detach an iterator from this sequence

  void __gnu_debug::_Safe_sequence_base::_M_detach_all () [protected], [inherited]
Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

  void __gnu_debug::_Safe_sequence_base::_M_detach_single (_Safe_iterator_base *__it) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_detach_singular () [protected], [inherited]
Detach all singular iterators.

Postcondition:
    for all iterators i attached to this sequence, i->_M_version == _M_version.

  __gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex () [protected], [inherited]
For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  void __gnu_debug::_Safe_sequence_base::_M_invalidate_all () const [inline], [inherited]
Invalidates all iterators.

Definition at line 233 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

  void __gnu_debug::_Safe_sequence< list< _Tp, _Allocator > >::_M_invalidate_if (_Predicate__pred) [inherited]
Invalidates all iterators x that reference this sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

  void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular () [protected], [inherited]
Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

  void __gnu_debug::_Safe_sequence_base::_M_swap (_Safe_sequence_base &__x) [protected], [inherited]
Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

  void __gnu_debug::_Safe_sequence< list< _Tp, _Allocator > >::_M_transfer_from_if (_Safe_sequence< list< _Tp, _Allocator > > &__from, _Predicate__pred) [inherited]
Transfers all iterators x that reference from sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Member Data Documentation

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators [inherited]

The list of constant iterators that reference this container.

Definition at line 184 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators [inherited]

The list of mutable iterators that reference this container.

Definition at line 181 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  unsigned int __gnu_debug::_Safe_sequence_base::_M_version [mutable], [inherited]

The container version number. This number may never be 0.

Definition at line 187 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

Author

Generated automatically by Doxygen for libstdc++ from the source code.